{
Copyright () 2005,  by Germn Estvez (Neftal)
http://neftali.clubdelphi.com/

  Muestra cmo dividir una imagen existente en N trozos al estilo de como se
  hace con los puzzles. Al acabar se graban las imgenes en disco.

=========================================================================
IMPORTANTE PROGRAMADORES: Por favor, si tienes comentarios, mejoras, ampliaciones,
  errores y/o cualquier otro tipo de sugerencia envame un mail a:
  german_ral@hotmail.com

IMPORTANT PROGRAMMERS: please, if you have comments, improvements, enlargements,
errors and/or any another type of suggestion send a mail to:
german_ral@hotmail.com
=========================================================================

@author Germn Estvez (Neftal)
@cat Samples
}
unit Unit1;

//=========================================================================
//
// I N T E R F A C E
//
//=========================================================================
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, jpeg, ExtCtrls,
  ShellAPI, ComCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Button3: TButton;
    Edit1: TEdit;
    StatusBar1: TStatusBar;
    Label1: TLabel;
    edtImage: TEdit;
    Label2: TLabel;
    Button2: TButton;
    ProgressBar1: TProgressBar;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure StatusBar1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

//=========================================================================
//
// I M P L E M E N T A T I O N
//
//=========================================================================
implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
//const
//   nn: integer = 4;
var
   bmp: TBitmap;
   bmpij: TBitmap;
   src: TRect;
   i,j: integer;
   w,h: single;
   i1,i2,j1,j2: integer;
   resImage:TImage;
   FileNAme:String;
   nn:Integer;
begin

  // desactivar botones
  Button1.Enabled := False;
  Button3.Enabled := False;

  // Divisiones por defecto
  nn := 4;

  // Intentar capturar el nmero y convertirlo
  try
    nn := StrToInt(Edit1.Text);
    // Progress
    ProgressBar1.Min := 0;
    ProgressBar1.Max := nn;

    // Controlar
    if (nn < 2) and (nn > 30) then begin
      MessageDlg('El nmero de divisiones debe estar entre 2 y 20 (ambos inclusive)', mtError, [mbOK], 0);
      Exit;
    end;
  except
    on e:Exception do begin
      // Nada
    end;
  end;

  // Crear el bitmap
  bmp := TBitmap.create;

  // Cargar imagen
  bmp.Assign(Image1.Picture.Bitmap);

  // Calcular divisiones
  w := bmp.width/nn;
  h := bmp.height/nn;
  // Ocultamos la original
  Image1.Visible := False;

  // Recorrer y crear la imagenes pequeas
  for i := 1 to nn do begin
    // Progress
    ProgressBar1.Position := i;

    i1 := round((i-1)*w);
    i2 := round(i*w);
    for j := 1 to nn do begin
      // nueva imagen
      bmpij := TBitmap.create;
      // proteccion
      try
        bmpij.width := round(w);
        bmpij.height := round(h);
        j1 := round((j-1)*h);
        j2 := round(j*h);
        src := rect(i1,j1,i2,j2);
        // Mismo formato
        bmpij.PixelFormat := bmp.PixelFormat;
        // Copiar a la imagen pequea el "trozo" correspondiente
        bmpij.canvas.copyrect(bmpij.canvas.ClipRect, bmp.canvas, src);
        // Fichero de salida
        FileName := format('.\output_%d_%d.BMP',[i,j]);
        // Grabar
        bmpij.savetofile(FileName);
      finally
        bmpij.free;
      end;

      // Crear los controles para las imagenes en pantalla
      resImage := TImage.Create(Self);
      resImage.Parent := Self;
      resImage.Left := Image1.Left + Round((i - 1) * (w + 2));
      resImage.Top := Image1.Top + Round((j - 1) * (h + 2));
      resImage.Picture.Bitmap.LoadFromFile(FileName);

    end;
  end;

  MessageDlg(Format('Las imagenes se han guardado en disco (mismo directorio de la ' +
                    'aplicacin) con los nombres:' + #10#13 +
                    '* %s' + #10#13 +
                    '* ...' + #10#13 +
                    '* %s',[format('.\output_%d_%d.BMP',[1,1]),
                           format('.\output_%d_%d.BMP',[nn,nn])]),
                    mtInformation, [mbOK], 0);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin

  // no Existe
  if not (FileExists(edtImage.Text)) then begin
    MessageDlg(Format('No se encuentra la imagen <%s>en disco.',[edtImage.Text]), mtError, [mbOK], 0);
    Exit;
  end;

  // Si llega aqui se ha ledo correctamente
  Button1.Enabled := True;
  // Leer la imagen
  Image1.Picture.Bitmap.LoadFromFile(edtImage.Text);
end;

procedure TForm1.StatusBar1Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open', 'http://neftali.clubdelphi.com/', 0, 0, 0);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  // Acabar
  Application.Terminate;
end;

end.

